<?php defined("SYSPATH") or die("No direct script access.");/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2011 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class videothumb_Controller extends Controller {
  public function index() {
    print $this->_get_form();
  }
  
  function dialog($item_id) {
    $item = ORM::factory("item", $item_id);
    access::required("view", $item);
    access::required("edit", $item);
    $v = new View("videothumb_dialog.html");

    $v->item = $item;
    //video length
    $v->videolength = $this->get_duration_manual($item);
    $v->second = isset($_POST['second'])?$_POST['second']:'03';
    if($_POST['sent']) {
        $this->extract_frame_manual($item_id);
    }
    print json::reply(array("html" => (string)$v ));
  }
  
  public function handler() {
    access::verify_csrf();

    $form = $this->_get_form();
    if ($form->validate()) {
      // @todo process the admin form

      message::success(t("videothumb Processing Successfully"));

      json::reply(array("result" => "success"));
    } else {
      json::reply(array("result" => "error", "html" => (string)$form));
    }
  }

  private function _get_form() {
    $form = new Forge("videothumb/handler", "", "post",
                      array("id" => "g-videothumb-form"));
    $group = $form->group("group")->label(t("videothumb Handler"));
    $group->input("text")->label(t("Text"))->rules("required");
    $group->submit("submit")->value(t("Submit"));
    echo "Form";

    return $form;
  }
  
  static function extract_frame_manual($item) {
    $ffmpeg = movie::find_ffmpeg();
    if (empty($ffmpeg)) {
      throw new Exception("@todo MISSING_FFMPEG");
    }
    $input_file = $_POST['file_path'];
    $output_file = $_POST['thumb_path'];       
    // Convert the movie to a JPG first
    $output_file = preg_replace("/...$/", "jpg", $output_file);
    $second = date("H:i:s", mktime(0,0,$_POST['second'],0,0,0,0));
    
    $cmd = escapeshellcmd($ffmpeg) . " -ss ".$second." -i " . escapeshellarg($input_file) .
      " -an -an -r 1 -vframes 1" .
      " -y -f mjpeg -s ".$_POST['thumb_width']."x".$_POST['thumb_height']." ". escapeshellarg($output_file) . " 2>&1";
    exec($cmd);

    clearstatcache();  // use $filename parameter when PHP_version is 5.3+
    if (filesize($output_file) == 0) {
      // Maybe the movie is shorter, fall back to the first frame.
      $cmd = escapeshellcmd($ffmpeg) . " -i " . escapeshellarg($input_file) .
        " -an -an -r 1 -vframes 1" .
        " -y -f mjpeg -s ".$_POST['thumb_width']."x".$_POST['thumb_height']." " . escapeshellarg($output_file) . " 2>&1";
      exec($cmd);

      clearstatcache();
      if (filesize($output_file) == 0) {
        throw new Exception("@todo FFMPEG_FAILED");
      }
    }
  }
  
  static function get_duration_manual($item) {
    $ffmpeg = movie::find_ffmpeg();
    if (empty($ffmpeg)) {
      throw new Exception("@todo MISSING_FFMPEG");
    }
    
    $cmd = escapeshellcmd($ffmpeg) . " -i " . escapeshellarg($item->file_path()) . " 2>&1";
    $result = `$cmd`;
    if (preg_match("/Duration: (\d+):(\d+):(\d+\.\d+)/", $result, $regs)) {
      return 3600 * $regs[1] + 60 * $regs[2] + $regs[3];
    } else if (preg_match("/duration.*?:.*?(\d+)/", $result, $regs)) {
      return $regs[1];
    } else {
      return '00';
    }
  }  
  
}
